﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Test1
{
  public partial class Form1 : Form
  {
    F_LCEVENT LcEvent;
    IntPtr m_hLcWnd, m_hDrw, m_hProps;
    static IntPtr m_hStatBar;
    int m_PropsWidth = 250;

    public Form1()
    {
      InitializeComponent();
    }

    private void Form1_Load(object sender, EventArgs e)
    {
      IntPtr hObj0 = new IntPtr(0);
      Lcad.PropPutStr(hObj0, Lcad.LC_PROP_G_REGCODE, "123");
      // define event procedure
      LcEvent = new F_LCEVENT(Form1.LcEventProc);
      Lcad.EventSetProc(Lcad.LC_EVENT_MOUSEMOVE, LcEvent, 0, hObj0);
      Lcad.EventSetProc(Lcad.LC_EVENT_WNDVIEW, LcEvent, 0, hObj0);
      Lcad.EventSetProc(Lcad.LC_EVENT_GRIPMOVE, LcEvent, 0, hObj0);
      // initialize Litecad dll
      Lcad.Initialize();

      // create CAD window
      // the size will be set in Form1_Resize()
      m_hLcWnd = Lcad.CreateWindow(Handle, Lcad.LC_WS_DEFAULT+Lcad.LC_WS_RULERS);  

      // create Properties window
      m_hProps = Lcad.CreateProps(Handle,0);   // the size will be set in Form1_Resize()
      // link with graphics window
      Lcad.WndSetProps(m_hLcWnd, m_hProps);

      // Create StatusBar
      m_hStatBar = Lcad.CreateStatbar( Handle );
      // define statusbar fields
      Lcad.StatbarCell( m_hStatBar, 1, 0 );
      Lcad.StatbarCell( m_hStatBar, 2, 100 );
      Lcad.StatbarCell( m_hStatBar, 3, 200 );
      Lcad.StatbarCell( m_hStatBar, 4, 350 );

      Form1_Resize(sender, e);
        
      // create a drawing object
      m_hDrw = Lcad.CreateDrawing();
      Lcad.DrwNew(m_hDrw, "", m_hLcWnd);

      // zoom extents
      Lcad.WndZoomRect( m_hLcWnd, 0, 0, 100, 100 );
      Lcad.WndSetFocus(m_hLcWnd);


//      if (Lcad.PropPutStr(m_hLcWnd, Lcad.LC_PROP_WND_BGIMAGE, "d:\\back1.bmp") == true)
//      {
//        Lcad.PropPutBool(m_hLcWnd, Lcad.LC_PROP_WND_BGIMAGE, true);
//      }


      // disable selection by rect
//      Lcad.PropPutBool(m_hLcWnd, Lcad.LC_PROP_WND_SELBYRECT, false);
    }

    private void Form1_FormClosed(object sender, FormClosedEventArgs e)
    {
      Lcad.Uninitialize( true );
      Lcad.DeleteDrawing( m_hDrw );
    }

    private void Form1_Resize(object sender, EventArgs e)
    {
      int Hmenu, Hsbar, x, y, w, h;
      IntPtr hObj0 = new IntPtr(0);

      Hmenu = menuStrip1.Height;

      // Height of the status bar
      Hsbar = Lcad.PropGetInt(hObj0, Lcad.LC_PROP_G_SBARHEIGHT);

      // "Properties" window position
      x = 0;
      y = Hmenu;
      w = m_PropsWidth;
      h = ClientSize.Height - Hmenu - Hsbar + 1;
      Lcad.PropsResize( m_hProps, x, y, w, h );

      // "CAD window" position
      x = m_PropsWidth;
      y = Hmenu;
      w = ClientSize.Width - m_PropsWidth + 1;
      h = ClientSize.Height - Hmenu - Hsbar + 1;
      Lcad.WndResize( m_hLcWnd, x, y, w, h );

      // StatusBar position
      x = 0;
      y = ClientSize.Height - Hsbar;
      w = ClientSize.Width;
      h = Hsbar;
      Lcad.StatbarResize( m_hStatBar, x, y, w, h );
    }

    public static void LcEventProc(IntPtr hEvent)
    {
      int EventType;
      EventType = Lcad.PropGetInt(hEvent, Lcad.LC_PROP_EVENT_TYPE);
      switch( EventType )
      {
        case Lcad.LC_EVENT_MOUSEMOVE: OnMouseMove(hEvent); break;
        case Lcad.LC_EVENT_WNDVIEW:   OnWndView(hEvent); break;
//        case Lcad.LC_EVENT_LBDOWN:    OnLBDown(hEvent); break;
//        case Lcad.LC_EVENT_PICKENT:   OnPickEnt(hEvent); break;
        case Lcad.LC_EVENT_GRIPMOVE:  OnGripMove(hEvent); break;
      }
    }

    public static void OnMouseMove(IntPtr hEvent)
    {
      string szBuf;
      double X, Y;
      IntPtr hLcWnd;

      hLcWnd = Lcad.PropGetHandle( hEvent, Lcad.LC_PROP_EVENT_WND );
      // Cursor coordinates
      X = Lcad.PropGetFloat( hEvent, Lcad.LC_PROP_EVENT_FLOAT1 );
      Y = Lcad.PropGetFloat( hEvent, Lcad.LC_PROP_EVENT_FLOAT2 );
      // Display data in status bar
      // X
      szBuf = X.ToString("F3");
      Lcad.StatbarText( m_hStatBar, 1, szBuf );
      // Y
      szBuf = Y.ToString("F3");
      Lcad.StatbarText(m_hStatBar, 2, szBuf);
      // redraw the status bar
      Lcad.StatbarRedraw( m_hStatBar );
    }

    public static void OnWndView(IntPtr hEvent)
    {
      double X, Y, PixSize, Lef, Bot, Rig, Top, dx, dy;
      string szBuf;
      IntPtr hLcWnd;

      hLcWnd = Lcad.PropGetHandle( hEvent, Lcad.LC_PROP_EVENT_WND );
      PixSize = Lcad.PropGetFloat( hLcWnd, Lcad.LC_PROP_WND_PIXELSIZE );
      X = Lcad.PropGetFloat( hLcWnd, Lcad.LC_PROP_WND_CURX );
      Y = Lcad.PropGetFloat( hLcWnd, Lcad.LC_PROP_WND_CURY );
      Lef = Lcad.PropGetFloat( hLcWnd, Lcad.LC_PROP_WND_XMIN );
      Bot = Lcad.PropGetFloat( hLcWnd, Lcad.LC_PROP_WND_YMIN );
      Rig = Lcad.PropGetFloat( hLcWnd, Lcad.LC_PROP_WND_XMAX );
      Top = Lcad.PropGetFloat( hLcWnd, Lcad.LC_PROP_WND_YMAX );
      dx = Rig - Lef;
      dy = Top - Bot;

      // Display data in status bar
      // X
      szBuf = X.ToString("F3");
      Lcad.StatbarText( m_hStatBar, 1, szBuf );
      // Y
      szBuf = Y.ToString("F3");
      Lcad.StatbarText( m_hStatBar, 2, szBuf );
      // Pixel size
      szBuf = "Pixel size: "+PixSize.ToString("F4");
      Lcad.StatbarText( m_hStatBar, 3, szBuf );
      // visible area
      szBuf = "Visible area:  L=" + Lef.ToString("F2") + "  B=" + Bot.ToString("F2") + "  R=" + Rig.ToString("F2") + "  T=" + Bot.ToString("F2")+"   W="+dx.ToString("F2")+"  H="+dy.ToString("F2");
      Lcad.StatbarText( m_hStatBar, 4, szBuf );
      // redraw the status bar
      Lcad.StatbarRedraw( m_hStatBar );
    }

    public static void OnPickEnt(IntPtr hEvent)
    {
      Lcad.EventReturnCode(1);
    }

    public static void OnLBDown(IntPtr hEvent)
    {
      IntPtr hEnt;
      IntPtr hObj0 = new IntPtr(0);
      double X = Lcad.PropGetFloat(hEvent, Lcad.LC_PROP_EVENT_FLOAT1);
      double Y = Lcad.PropGetFloat(hEvent, Lcad.LC_PROP_EVENT_FLOAT2);
      int x = Lcad.PropGetInt(hEvent, Lcad.LC_PROP_EVENT_INT1);
      int y = Lcad.PropGetInt(hEvent, Lcad.LC_PROP_EVENT_INT2);
      IntPtr hLcWnd = Lcad.PropGetHandle(hEvent, Lcad.LC_PROP_EVENT_WND);
      double PickBoxSize;
      int Col;

      if (Lcad.PropGetBool(hLcWnd, Lcad.LC_PROP_WND_COMMAND) == false)
      {
        // no active command
        PickBoxSize = Lcad.PropGetFloat(hLcWnd, Lcad.LC_PROP_WND_PICKBOXSIZE);
//        hEnt = Lcad.WndGetEntByPoint(hLcWnd, x, y);
        hEnt = Lcad.WndGetEntByPoint2( hLcWnd, X, Y, PickBoxSize );
        if (hEnt!=hObj0)
        {
          Col = Lcad.PropGetInt(hEnt, Lcad.LC_PROP_ENT_COLORT);
          if (Col == 255)
          {
            Lcad.PropPutInt(hEnt, Lcad.LC_PROP_ENT_COLORT, 65280 );
          }
          else
          {
            Lcad.PropPutInt(hEnt, Lcad.LC_PROP_ENT_COLORT, 255);
          }
          Lcad.WndRedraw(hLcWnd);
        }
      }
    }

    public static void OnGripMove(IntPtr hEvent)
    {
      IntPtr hBlock = Lcad.PropGetHandle( hEvent, Lcad.LC_PROP_EVENT_BLOCK );
      double X = Lcad.PropGetFloat(hEvent, Lcad.LC_PROP_EVENT_FLOAT1);
      double Y = Lcad.PropGetFloat(hEvent, Lcad.LC_PROP_EVENT_FLOAT2);
      Lcad.BlockAddCircle( hBlock, X,Y, 1.0, false );
    }

    private void newToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.DrwNew(m_hDrw, "", m_hLcWnd);
    }

    private void openToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.DrwLoad(m_hDrw, "<Dialog>", m_hLcWnd);
    }

    private void recentToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.DrwLoad(m_hDrw, "<Recent>", m_hLcWnd);
    }

    private void saveToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_FILESAVE, 0);
    }

    private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_FILESAVEAS, 0);
    }

    private void printToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_PRINT, 0);
    }

    private void lineToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_LINE, 0);
    }

    private void polylineToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_POLYLINE, 0);
    }

    private void circleToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_CIRCLE, 0);
    }

    private void arcToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_ARC, 0);
    }

    private void textToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_TEXT, 0);
    }
    private void blockToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_CREBLOCK, 0);
    }

    private void layersToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_LAYER, 0);
    }

    private void linetypesToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_LINETYPE, 0);
    }

    private void textStylesToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_TEXTSTYLE, 0);
    }

    private void blocksToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_BLOCKS, 0);
    }

    private void distanceToolStripMenuItem_Click(object sender, EventArgs e)
    {
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_DIST, 0);
/*
      String Txt;
      int hLayer;
      hLayer = Lcad.DrwGetFirstObject(m_hDrw, Lcad.LC_OBJ_LAYER);
      while( hLayer != 0){
        Txt = Lcad.PropGetStr(hLayer, Lcad.LC_PROP_LAYER_NAME);
        hLayer = Lcad.DrwGetNextObject(m_hDrw, hLayer);
      }
*/
    }

    private void generateDrawingToolStripMenuItem_Click(object sender, EventArgs e)
    {
      IntPtr hBlock, hEnt, hPline, hTextStyle;
      IntPtr hObj0 = new IntPtr(0);

      Lcad.DrwNew(m_hDrw, "", m_hLcWnd);
      Lcad.PropPutBool(m_hLcWnd, Lcad.LC_PROP_WND_ALPHABLEND, true);

      // get "Model" block
      hBlock = Lcad.DrwGetFirstObject(m_hDrw, Lcad.LC_OBJ_BLOCK);
      // another method to get "Model" block
//      hBlock = Lcad.PropGetHandle(m_hDrw, Lcad.LC_PROP_DRW_BLOCK_MODEL);

      // add Circle
      hEnt = Lcad.BlockAddCircle(hBlock, 0, 0, 30, true);
      Lcad.PropPutStr(hEnt, Lcad.LC_PROP_ENT_FCOLOR, "100,200,250");
      // add Rectangle
      hEnt = Lcad.BlockAddRect2(hBlock, 0, 0, 100, 20, 0, true);
      Lcad.PropPutStr(hEnt, Lcad.LC_PROP_ENT_COLOR, "green");
      Lcad.PropPutStr(hEnt, Lcad.LC_PROP_ENT_FCOLOR, "red");
      Lcad.PropPutInt(hEnt, Lcad.LC_PROP_ENT_FALPHA, 100);
      // add Ellipse
      hEnt = Lcad.BlockAddEllipse(hBlock, 20, 30, 40, 15, 0, 0, 0);
      Lcad.PropPutStr(hEnt, Lcad.LC_PROP_ENT_COLOR, "red");
      // add Polyline
      hPline = Lcad.BlockAddPolyline(hBlock, 0, false, false);
      Lcad.PlineAddVer(hPline, hObj0, 0, 50);
      Lcad.PlineAddVer(hPline, hObj0, 20, 80);
      Lcad.PlineAddVer(hPline, hObj0, 40, 50);
      Lcad.PlineAddVer(hPline, hObj0, 60, 80);
      Lcad.PlineAddVer(hPline, hObj0, 80, 50);
      // add text style 
      hTextStyle = Lcad.DrwAddTextStyle( m_hDrw, "qwert", "Arial", true );
      if (hTextStyle != hObj0)
      {
        Lcad.PropPutFloat(hTextStyle, Lcad.LC_PROP_TSTYLE_HEIGHT, 5.0);
        Lcad.PropPutInt(hTextStyle, Lcad.LC_PROP_TSTYLE_ALIGN, Lcad.LC_TA_CENTER);
        // select active text style
        Lcad.PropPutHandle(m_hDrw, Lcad.LC_PROP_DRW_TEXTSTYLE, hTextStyle);
      }
      // add text
      Lcad.BlockAddText(hBlock, "Hello World!", 50, 10);

      Lcad.BlockUpdate(hBlock, true, hObj0);
      // zoom extents
      Lcad.WndExeCommand(m_hLcWnd, Lcad.LC_CMD_ZOOM_EXT, 0);
      Lcad.WndZoomScale(m_hLcWnd, 0.7);
      Lcad.WndSetFocus(m_hLcWnd);
    }

  }
}
